#include <iostream>
#include "scoreboard.hpp"

// Uns poucos testes da classe Scoreboard.
int main(int, char const *[]) {
    Scoreboard s(5);
    auto scores = s.largest_scores();
    if (scores.size() != 0) {
        std::cerr << "ERRO: Retornou scores inexistentes!\n";
    }
    else {
        std::cout << "OK: Placar vazio.\n";
    }

    s.insert(3.0);
    scores = s.largest_scores();
    if (scores.size() != 1 || scores[0] != 3.0) {
        std::cerr << "ERRO: Falhou tentando inserir um score.\n";
    }
    else {
        std::cout << "OK: Insercao de um valor.\n";
    }

    std::vector<double> some_scores{1.0, 1.5, 0.2, 7.0, -2.0, 10.0, 9.0};
    for (auto scr: some_scores) {
        s.insert(scr);
    }
    scores = s.largest_scores();

    std::vector<double> expected_scores{10.0, 9.0, 7.0, 3.0, 1.5};
    if (scores != expected_scores) {
        std::cerr << "ERRO: Falhou em entregar scores corretamente.\n";
    }
    else {
        std::cout << "OK: Insercao de varios valores.\n";
    }
}
